define("SectionActionsDashboard", ["SectionActionsDashboardResources", "CallsMessagePublisherModule"],
	function(resources) {
		return {
			attributes: {},
			messages: {},
			methods: {
				getExtendedConfig: function() {
					var config = this.callParent(arguments);
					var lczImages = resources.localizableImages;
					config.CallsMessageTab = {
						"ImageSrc": this.Terrasoft.ImageUrlBuilder.getUrl(lczImages.CallsMessageTabImage),
						"MarkerValue": "calls-message-tab",
						"Align": this.Terrasoft.Align.RIGHT,
						"Tag": "Calls"
					};
					return config;
				},
				onGetRecordInfoForPublisher: function() {
					var info = this.callParent(arguments);
					info.additionalInfo.contact = this.getContactEntityParameterValue(info.relationSchemaName);
					return info;
				},
				getContactEntityParameterValue: function(relationSchemaName) {
					var contact;
					if (relationSchemaName === "Contact") {
						var id = this.getMasterEntityParameterValue("Id");
						var name = this.getMasterEntityParameterValue("Name");
						if (id && name) {
							contact = {value: id, displayValue: name};
						}
					} else {
						contact = this.getMasterEntityParameterValue("Contact");
					}
					return contact;
				},
				getSectionPublishers: function() {
					var publishers = this.callParent(arguments);
					publishers.push("Calls");
					return publishers;
				}
			},
			diff: /**SCHEMA_DIFF*/[
				{
					"operation": "insert",
					"name": "CallsMessageTab",
					"parentName": "Tabs",
					"propertyName": "tabs",
					"values": {
						"items": []
					}
				},
				{
					"operation": "insert",
					"name": "CallsMessageTabContainer",
					"parentName": "CallsMessageTab",
					"propertyName": "items",
					"values": {
						"itemType": this.Terrasoft.ViewItemType.CONTAINER,
						"classes": {
							"wrapClassName": ["calls-message-content"]
						},
						"items": []
					}
				},
				{
					"operation": "insert",
					"name": "CallsMessageModule",
					"parentName": "CallsMessageTab",
					"propertyName": "items",
					"values": {
						"classes": {
							"wrapClassName": ["calls-message-module", "message-module"]
						},
						"itemType": this.Terrasoft.ViewItemType.MODULE,
						"moduleName": "callsMessagePublisherModule",
						"afterrender": {
							"bindTo": "onMessageModuleRendered"
						},
						"afterrerender": {
							"bindTo": "onMessageModuleRendered"
						}
					}
				}
			]/**SCHEMA_DIFF*/
		};
	}
);
